]> git.ipfire.org Git - thirdparty/git.git/blame - t/test-lib.sh
valgrind: ignore ldso and more libz errors
[thirdparty/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
5
c2116a17
JH
6# Keep the original TERM for say_color
7ORIGINAL_TERM=$TERM
8
e1970ce4
JH
9# For repeatability, reset the environment to known value.
10LANG=C
899460f3 11LC_ALL=C
d9bdd39e 12PAGER=cat
e1970ce4 13TZ=UTC
c2116a17
JH
14TERM=dumb
15export LANG LC_ALL PAGER TERM TZ
8ff99e74
EW
16EDITOR=:
17VISUAL=:
18508c39 18unset GIT_EDITOR
e1970ce4
JH
19unset AUTHOR_DATE
20unset AUTHOR_EMAIL
21unset AUTHOR_NAME
22unset COMMIT_AUTHOR_EMAIL
23unset COMMIT_AUTHOR_NAME
28a94f88 24unset EMAIL
e1970ce4
JH
25unset GIT_ALTERNATE_OBJECT_DIRECTORIES
26unset GIT_AUTHOR_DATE
29e55cd5
JH
27GIT_AUTHOR_EMAIL=author@example.com
28GIT_AUTHOR_NAME='A U Thor'
6677c466 29unset GIT_COMMITTER_DATE
29e55cd5
JH
30GIT_COMMITTER_EMAIL=committer@example.com
31GIT_COMMITTER_NAME='C O Mitter'
e1970ce4
JH
32unset GIT_DIFF_OPTS
33unset GIT_DIR
892c41b9 34unset GIT_WORK_TREE
e1970ce4
JH
35unset GIT_EXTERNAL_DIFF
36unset GIT_INDEX_FILE
37unset GIT_OBJECT_DIRECTORY
0454dd93 38unset GIT_CEILING_DIRECTORIES
e1970ce4
JH
39unset SHA1_FILE_DIRECTORIES
40unset SHA1_FILE_DIRECTORY
8d0fc48f
SP
41GIT_MERGE_VERBOSITY=5
42export GIT_MERGE_VERBOSITY
29e55cd5
JH
43export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
44export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
8ff99e74 45export EDITOR VISUAL
82ebb0b6 46GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
e1970ce4 47
886a3907
JH
48# Protect ourselves from common misconfiguration to export
49# CDPATH into the environment
50unset CDPATH
51
3d5c0cc9 52case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
6ce4e61f
CC
53 1|2|true)
54 echo "* warning: Some tests will not work if GIT_TRACE" \
55 "is set as to trace on STDERR ! *"
56 echo "* warning: Please set GIT_TRACE to something" \
57 "other than 1, 2 or true ! *"
58 ;;
59esac
60
e1970ce4
JH
61# Each test should start with something like this, after copyright notices:
62#
63# test_description='Description of this test...
64# This test checks if command xyzzy does the right thing...
65# '
66# . ./test-lib.sh
c2116a17
JH
67[ "x$ORIGINAL_TERM" != "xdumb" ] && (
68 TERM=$ORIGINAL_TERM &&
69 export TERM &&
70 [ -t 1 ] &&
71 tput bold >/dev/null 2>&1 &&
72 tput setaf 1 >/dev/null 2>&1 &&
73 tput sgr0 >/dev/null 2>&1
74 ) &&
55db1df0 75 color=t
e1970ce4 76
e1970ce4
JH
77while test "$#" -ne 0
78do
79 case "$1" in
80 -d|--d|--de|--deb|--debu|--debug)
81 debug=t; shift ;;
886856ab
JH
82 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
83 immediate=t; shift ;;
5e2c08c6
LW
84 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
85 export GIT_TEST_LONG=t; shift ;;
e1970ce4 86 -h|--h|--he|--hel|--help)
570f3226 87 help=t; shift ;;
e1970ce4
JH
88 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
89 verbose=t; shift ;;
1ece1274
PH
90 -q|--q|--qu|--qui|--quie|--quiet)
91 quiet=t; shift ;;
55db1df0 92 --no-color)
faa4bc35 93 color=; shift ;;
abb7c7b3 94 --no-python)
7cdbff14
JH
95 # noop now...
96 shift ;;
4e1be63c
JS
97 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
98 valgrind=t; shift ;;
e1970ce4
JH
99 *)
100 break ;;
101 esac
102done
103
55db1df0
PH
104if test -n "$color"; then
105 say_color () {
c2116a17
JH
106 (
107 TERM=$ORIGINAL_TERM
108 export TERM
55db1df0
PH
109 case "$1" in
110 error) tput bold; tput setaf 1;; # bold red
111 skip) tput bold; tput setaf 2;; # bold green
112 pass) tput setaf 2;; # green
113 info) tput setaf 3;; # brown
1ece1274 114 *) test -n "$quiet" && return;;
55db1df0
PH
115 esac
116 shift
72d404de 117 printf "* %s" "$*"
55db1df0 118 tput sgr0
b8eecafd 119 echo
c2116a17 120 )
55db1df0
PH
121 }
122else
123 say_color() {
1ece1274 124 test -z "$1" && test -n "$quiet" && return
55db1df0
PH
125 shift
126 echo "* $*"
127 }
128fi
129
130error () {
131 say_color error "error: $*"
35641310 132 trap - EXIT
55db1df0
PH
133 exit 1
134}
135
136say () {
137 say_color info "$*"
138}
139
570f3226
MB
140test "${test_description}" != "" ||
141error "Test script did not set test_description."
142
143if test "$help" = "t"
144then
145 echo "$test_description"
146 exit 0
147fi
148
4d9d62fa 149exec 5>&1
e1970ce4
JH
150if test "$verbose" = "t"
151then
152 exec 4>&2 3>&1
153else
154 exec 4>/dev/null 3>/dev/null
155fi
156
157test_failure=0
158test_count=0
41ac414e
JH
159test_fixed=0
160test_broken=0
2d84e9fb 161test_success=0
e1970ce4 162
faa4bc35
CB
163die () {
164 echo >&5 "FATAL: Unexpected exit with code $?"
165 exit 1
166}
167
35641310 168trap 'die' EXIT
41184273 169
02b35660
BD
170# The semantics of the editor variables are that of invoking
171# sh -c "$EDITOR \"$@\"" files ...
172#
173# If our trash directory contains shell metacharacters, they will be
174# interpreted if we just set $EDITOR directly, so do a little dance with
175# environment variables to work around this.
176#
177# In particular, quoting isn't enough, as the path may contain the same quote
7b7b4516 178# that we're using.
02b35660
BD
179test_set_editor () {
180 FAKE_EDITOR="$1"
181 export FAKE_EDITOR
182 VISUAL='"$FAKE_EDITOR"'
183 export VISUAL
184}
185
04509738
JH
186test_tick () {
187 if test -z "${test_tick+set}"
188 then
21afc41c 189 test_tick=1112911993
04509738
JH
190 else
191 test_tick=$(($test_tick + 60))
192 fi
21afc41c
JH
193 GIT_COMMITTER_DATE="$test_tick -0700"
194 GIT_AUTHOR_DATE="$test_tick -0700"
04509738
JH
195 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
196}
e1970ce4 197
00884968
JS
198# Call test_commit with the arguments "<message> [<file> [<contents>]]"
199#
200# This will commit a file with the given contents and the given commit
201# message. It will also add a tag with <message> as name.
202#
203# Both <file> and <contents> default to <message>.
204
205test_commit () {
e656fc97 206 file=${2:-"$1.t"}
00884968
JS
207 echo "${3-$1}" > "$file" &&
208 git add "$file" &&
209 test_tick &&
210 git commit -m "$1" &&
211 git tag "$1"
212}
213
214# Call test_merge with the arguments "<message> <commit>", where <commit>
215# can be a tag pointing to the commit-to-merge.
216
217test_merge () {
218 test_tick &&
219 git merge -m "$1" "$2" &&
220 git tag "$1"
221}
222
886856ab
JH
223# You are not expected to call test_ok_ and test_failure_ directly, use
224# the text_expect_* functions instead.
225
226test_ok_ () {
e1970ce4 227 test_count=$(expr "$test_count" + 1)
2d84e9fb 228 test_success=$(expr "$test_success" + 1)
55db1df0 229 say_color "" " ok $test_count: $@"
e1970ce4
JH
230}
231
886856ab 232test_failure_ () {
e1970ce4
JH
233 test_count=$(expr "$test_count" + 1)
234 test_failure=$(expr "$test_failure" + 1);
55db1df0 235 say_color error "FAIL $test_count: $1"
bf0dd8a8
JH
236 shift
237 echo "$@" | sed -e 's/^/ /'
35641310 238 test "$immediate" = "" || { trap - EXIT; exit 1; }
886856ab
JH
239}
240
41ac414e
JH
241test_known_broken_ok_ () {
242 test_count=$(expr "$test_count" + 1)
243 test_fixed=$(($test_fixed+1))
244 say_color "" " FIXED $test_count: $@"
245}
246
247test_known_broken_failure_ () {
248 test_count=$(expr "$test_count" + 1)
249 test_broken=$(($test_broken+1))
250 say_color skip " still broken $test_count: $@"
251}
886856ab
JH
252
253test_debug () {
8e832ebc 254 test "$debug" = "" || eval "$1"
e1970ce4
JH
255}
256
4d9d62fa 257test_run_ () {
4d9d62fa
PR
258 eval >&3 2>&4 "$1"
259 eval_ret="$?"
4d9d62fa
PR
260 return 0
261}
262
04ece593
JH
263test_skip () {
264 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
265 this_test="$this_test.$(expr "$test_count" + 1)"
266 to_skip=
267 for skp in $GIT_SKIP_TESTS
268 do
269 case "$this_test" in
270 $skp)
271 to_skip=t
272 esac
273 done
274 case "$to_skip" in
275 t)
55db1df0 276 say_color skip >&3 "skipping test: $@"
04ece593 277 test_count=$(expr "$test_count" + 1)
55db1df0 278 say_color skip "skip $test_count: $1"
04ece593
JH
279 : true
280 ;;
281 *)
282 false
283 ;;
284 esac
285}
286
e1970ce4 287test_expect_failure () {
8e832ebc 288 test "$#" = 2 ||
e1970ce4 289 error "bug in the test script: not 2 parameters to test-expect-failure"
04ece593 290 if ! test_skip "$@"
e1970ce4 291 then
41ac414e 292 say >&3 "checking known breakage: $2"
04ece593 293 test_run_ "$2"
41ac414e 294 if [ "$?" = 0 -a "$eval_ret" = 0 ]
04ece593 295 then
41ac414e 296 test_known_broken_ok_ "$1"
04ece593 297 else
41ac414e 298 test_known_broken_failure_ "$1"
04ece593 299 fi
e1970ce4 300 fi
7a0cf2d0 301 echo >&3 ""
e1970ce4
JH
302}
303
304test_expect_success () {
8e832ebc 305 test "$#" = 2 ||
e1970ce4 306 error "bug in the test script: not 2 parameters to test-expect-success"
04ece593 307 if ! test_skip "$@"
e1970ce4 308 then
04ece593
JH
309 say >&3 "expecting success: $2"
310 test_run_ "$2"
311 if [ "$?" = 0 -a "$eval_ret" = 0 ]
312 then
313 test_ok_ "$1"
314 else
315 test_failure_ "$@"
316 fi
e1970ce4 317 fi
7a0cf2d0 318 echo >&3 ""
e1970ce4
JH
319}
320
d3bfdb75
FK
321test_expect_code () {
322 test "$#" = 3 ||
323 error "bug in the test script: not 3 parameters to test-expect-code"
04ece593 324 if ! test_skip "$@"
d3bfdb75 325 then
04ece593
JH
326 say >&3 "expecting exit code $1: $3"
327 test_run_ "$3"
328 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
329 then
330 test_ok_ "$2"
331 else
332 test_failure_ "$@"
333 fi
d3bfdb75 334 fi
7a0cf2d0 335 echo >&3 ""
d3bfdb75
FK
336}
337
fb32c410
LW
338# test_external runs external test scripts that provide continuous
339# test output about their progress, and succeeds/fails on
340# zero/non-zero exit code. It outputs the test output on stdout even
341# in non-verbose mode, and announces the external script with "* run
342# <n>: ..." before running it. When providing relative paths, keep in
343# mind that all scripts run in "trash directory".
344# Usage: test_external description command arguments...
345# Example: test_external 'Perl API' perl ../path/to/test.pl
346test_external () {
347 test "$#" -eq 3 ||
348 error >&5 "bug in the test script: not 3 parameters to test_external"
349 descr="$1"
350 shift
351 if ! test_skip "$descr" "$@"
352 then
353 # Announce the script to reduce confusion about the
354 # test output that follows.
355 say_color "" " run $(expr "$test_count" + 1): $descr ($*)"
356 # Run command; redirect its stderr to &4 as in
357 # test_run_, but keep its stdout on our stdout even in
358 # non-verbose mode.
359 "$@" 2>&4
360 if [ "$?" = 0 ]
361 then
362 test_ok_ "$descr"
363 else
364 test_failure_ "$descr" "$@"
365 fi
366 fi
367}
368
369# Like test_external, but in addition tests that the command generated
370# no output on stderr.
371test_external_without_stderr () {
372 # The temporary file has no (and must have no) security
373 # implications.
374 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
375 stderr="$tmp/git-external-stderr.$$.tmp"
376 test_external "$@" 4> "$stderr"
377 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
378 descr="no stderr: $1"
379 shift
380 say >&3 "expecting no stderr from previous command"
381 if [ ! -s "$stderr" ]; then
382 rm "$stderr"
383 test_ok_ "$descr"
384 else
385 if [ "$verbose" = t ]; then
386 output=`echo; echo Stderr is:; cat "$stderr"`
387 else
388 output=
389 fi
390 # rm first in case test_failure exits.
391 rm "$stderr"
392 test_failure_ "$descr" "$@" "$output"
393 fi
394}
395
74359821
JH
396# This is not among top-level (test_expect_success | test_expect_failure)
397# but is a prefix that can be used in the test script, like:
398#
399# test_expect_success 'complain and die' '
400# do something &&
401# do something else &&
402# test_must_fail git checkout ../outerspace
403# '
404#
405# Writing this as "! git checkout ../outerspace" is wrong, because
406# the failure could be due to a segv. We want a controlled failure.
407
408test_must_fail () {
409 "$@"
5a269730 410 test $? -gt 0 -a $? -le 129 -o $? -gt 192
74359821
JH
411}
412
82ebb0b6
JK
413# test_cmp is a helper function to compare actual and expected output.
414# You can use it like:
415#
416# test_expect_success 'foo works' '
417# echo expected >expected &&
418# foo >actual &&
419# test_cmp expected actual
420# '
421#
422# This could be written as either "cmp" or "diff -u", but:
423# - cmp's output is not nearly as easy to read as diff -u
424# - not all diff versions understand "-u"
425
426test_cmp() {
427 $GIT_TEST_CMP "$@"
428}
429
0509eb21 430# Most tests can use the created repository, but some may need to create more.
eedf8f97
CW
431# Usage: test_create_repo <directory>
432test_create_repo () {
433 test "$#" = 1 ||
434 error "bug in the test script: not 1 parameter to test-create-repo"
435 owd=`pwd`
436 repo="$1"
bfdbee98 437 mkdir -p "$repo"
eedf8f97 438 cd "$repo" || error "Cannot setup test environment"
4c7ba956 439 "$GIT_EXEC_PATH/git" init "--template=$GIT_EXEC_PATH/templates/blt/" >&3 2>&4 ||
5c94f87e 440 error "cannot run git init -- have you built things yet?"
eedf8f97
CW
441 mv .git/hooks .git/hooks-disabled
442 cd "$owd"
443}
a6080a0a 444
e1970ce4 445test_done () {
35641310 446 trap - EXIT
2d84e9fb
SR
447 test_results_dir="$TEST_DIRECTORY/test-results"
448 mkdir -p "$test_results_dir"
449 test_results_path="$test_results_dir/${0%-*}-$$"
450
451 echo "total $test_count" >> $test_results_path
452 echo "success $test_success" >> $test_results_path
453 echo "fixed $test_fixed" >> $test_results_path
454 echo "broken $test_broken" >> $test_results_path
455 echo "failed $test_failure" >> $test_results_path
456 echo "" >> $test_results_path
41ac414e
JH
457
458 if test "$test_fixed" != 0
459 then
460 say_color pass "fixed $test_fixed known breakage(s)"
461 fi
462 if test "$test_broken" != 0
463 then
464 say_color error "still have $test_broken known breakage(s)"
11d54b8b
JH
465 msg="remaining $(($test_count-$test_broken)) test(s)"
466 else
467 msg="$test_count test(s)"
41ac414e 468 fi
e1970ce4 469 case "$test_failure" in
10b94e28 470 0)
e1970ce4 471 # We could:
9231e3a9 472 # cd .. && rm -fr 'trash directory'
e1970ce4
JH
473 # but that means we forbid any tests that use their own
474 # subdirectory from calling test_done without coming back
475 # to where they started from.
476 # The Makefile provided will clean this test area so
477 # we will leave things as they are.
478
11d54b8b 479 say_color pass "passed all $msg"
abc5d372
JS
480
481 test -d "$remove_trash" &&
482 cd "$(dirname "$remove_trash")" &&
483 rm -rf "$(basename "$remove_trash")"
484
e1970ce4
JH
485 exit 0 ;;
486
487 *)
11d54b8b 488 say_color error "failed $test_failure among $msg"
e1970ce4
JH
489 exit 1 ;;
490
491 esac
492}
493
494# Test the binaries we have just built. The tests are kept in
9adefee5 495# t/ subdirectory and are run in 'trash directory' subdirectory.
2d84e9fb 496TEST_DIRECTORY=$(pwd)
4e1be63c
JS
497if test -z "$valgrind"
498then
499 PATH=$TEST_DIRECTORY/..:$PATH
500 GIT_EXEC_PATH=$TEST_DIRECTORY/..
501else
502 make_symlink () {
503 test -h "$2" &&
504 test "$1" = "$(readlink "$2")" || {
505 # be super paranoid
506 if mkdir "$2".lock
507 then
508 rm -f "$2" &&
509 ln -s "$1" "$2" &&
510 rm -r "$2".lock
511 else
512 while test -d "$2".lock
513 do
514 say "Waiting for lock on $2."
515 sleep 1
516 done
517 fi
518 }
519 }
520
521 make_valgrind_symlink () {
522 # handle only executables
523 test -x "$1" || return
524
525 base=$(basename "$1")
526 symlink_target=$TEST_DIRECTORY/../$base
527 # do not override scripts
528 if test -x "$symlink_target" &&
529 test ! -d "$symlink_target" &&
530 test "#!" != "$(head -c 2 < "$symlink_target")"
531 then
532 symlink_target=../valgrind.sh
533 fi
534 # create the link, or replace it if it is out of date
535 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
536 }
537
538 # override all git executables in TEST_DIRECTORY/..
539 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
540 mkdir -p "$GIT_VALGRIND"/bin
541 for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
542 do
543 make_valgrind_symlink $file
544 done
545 PATH=$GIT_VALGRIND/bin:$PATH
546 GIT_EXEC_PATH=$GIT_VALGRIND/bin
547 export GIT_VALGRIND
548
549 make_symlink ../../../templates "$GIT_VALGRIND"/bin/templates || exit
550fi
8683a45d 551GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
8bfa6bd6 552unset GIT_CONFIG
8bfa6bd6
JK
553GIT_CONFIG_NOSYSTEM=1
554GIT_CONFIG_NOGLOBAL=1
555export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
49ccb087 556
6fcca938
PB
557GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
558export GITPERLLIB
eea42069
JH
559test -d ../templates/blt || {
560 error "You haven't built things yet, have you?"
561}
e1970ce4 562
56cf9806
EW
563if ! test -x ../test-chmtime; then
564 echo >&2 'You need to build test-chmtime:'
565 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
566 exit 1
567fi
568
7cf7f54a
JK
569. ../GIT-BUILD-OPTIONS
570
e1970ce4 571# Test repository
abc5d372 572test="trash directory.$(basename "$0" .sh)"
5a4a088a 573test ! -z "$debug" || remove_trash="$TEST_DIRECTORY/$test"
8d14ac94 574rm -fr "$test" || {
35641310 575 trap - EXIT
8d14ac94
JH
576 echo >&5 "FATAL: Cannot prepare test area"
577 exit 1
578}
579
4a7aaccd 580test_create_repo "$test"
1bd9c648
LW
581# Use -P to resolve symlinks in our working directory so that the cwd
582# in subprocesses like git equals our $PWD (for pathname comparisons).
583cd -P "$test" || exit 1
04ece593
JH
584
585this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
586for skp in $GIT_SKIP_TESTS
587do
588 to_skip=
589 for skp in $GIT_SKIP_TESTS
590 do
591 case "$this_test" in
592 $skp)
593 to_skip=t
594 esac
595 done
596 case "$to_skip" in
597 t)
55db1df0
PH
598 say_color skip >&3 "skipping test $this_test altogether"
599 say_color skip "skip all tests in $this_test"
04ece593
JH
600 test_done
601 esac
602done